cf/largefile.m4: Fix build with autoconf-2.72
[heimdal.git] / tests / gss / check-basic.in
blob8904310ab2285919523be764c8b7311615b4c5a9
1 #!/bin/sh
3 # Copyright (c) 2007 Kungliga Tekniska Högskolan
4 # (Royal Institute of Technology, Stockholm, Sweden).
5 # All rights reserved.
7 # Redistribution and use in source and binary forms, with or without
8 # modification, are permitted provided that the following conditions
9 # are met:
11 # 1. Redistributions of source code must retain the above copyright
12 # notice, this list of conditions and the following disclaimer.
14 # 2. Redistributions in binary form must reproduce the above copyright
15 # notice, this list of conditions and the following disclaimer in the
16 # documentation and/or other materials provided with the distribution.
18 # 3. Neither the name of the Institute nor the names of its contributors
19 # may be used to endorse or promote products derived from this software
20 # without specific prior written permission.
22 # THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND
23 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
24 # IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
25 # ARE DISCLAIMED. IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE
26 # FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
27 # DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
28 # OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
29 # HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
30 # LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
31 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
32 # SUCH DAMAGE.
34 # $Id$
37 env_setup="@env_setup@"
38 srcdir="@srcdir@"
39 objdir="@objdir@"
41 . ${env_setup}
43 # If there is no useful db support compiled in, disable test
44 ../db/have-db || exit 77
46 R=TEST.H5L.SE
48 port=@port@
50 keytabfile=${objdir}/server.keytab
51 keytab="FILE:${keytabfile}"
52 nokeytab="FILE:no-such-keytab"
53 cache="FILE:krb5ccfile"
54 cache2="FILE:krb5ccfile2"
55 nocache="FILE:no-such-cache"
57 kadmin="${kadmin} -l -r $R"
58 kdc="${kdc} --addresses=localhost -P $port"
60 acquire_cred="${TESTS_ENVIRONMENT} ../../lib/gssapi/test_acquire_cred"
61 test_kcred="${TESTS_ENVIRONMENT} ../../lib/gssapi/test_kcred"
62 test_add_store_cred="${TESTS_ENVIRONMENT} ../../lib/gssapi/test_add_store_cred"
64 KRB5_CONFIG="${objdir}/krb5.conf"
65 export KRB5_CONFIG
67 KRB5_KTNAME="${keytab}"
68 export KRB5_KTNAME
69 KRB5CCNAME="${cache}"
70 export KRB5CCNAME
72 rm -f ${keytabfile}
73 rm -f current-db*
74 rm -f out-*
75 rm -f mkey.file*
77 > messages.log
79 echo upw > ${objdir}/foopassword
81 echo Creating database
82 ${kadmin} <<EOF || exit 1
83 init --realm-max-ticket-life=1day --realm-max-renewable-life=1month ${R}
84 add -p upw --use-defaults user@${R}
85 add -p upw --use-defaults another@${R}
86 add -p p1 --use-defaults host/host.test.h5l.se@${R}
87 ext -k ${keytab} host/host.test.h5l.se@${R}
88 check ${R}
89 EOF
91 echo Starting kdc
92 ${kdc} --detach --testing || { echo "kdc failed to start"; cat messages.log; exit 1; }
93 kdcpid=`getpid kdc`
95 cleanup() {
96 echo signal killing kdc
97 kill -9 ${kdcpid}
98 trap '' EXIT INT TERM
99 cat messages.log
100 exit 1
102 trap cleanup EXIT INT TERM
104 exitcode=0
106 echo "initial ticket"
107 ${kinit} -c ${cache} --password-file=${objdir}/foopassword user@${R} || exitcode=1
109 echo "copy ccache with gss_store_cred"
110 # Note we test that the ccache used for storing is token-expanded
111 ${test_add_store_cred} --default --overwrite --env ${cache} "${cache2}%{null}" || exit 1
112 ${klist} -c ${cache2} || exit 1
114 echo "keytab"
115 ${acquire_cred} \
116 --acquire-type=accept \
117 --acquire-name=host@host.test.h5l.se || exit 1
119 echo "keytab w/ short-form name and name canon rules"
120 ${acquire_cred} \
121 --acquire-type=accept \
122 --acquire-name=host@host || exit 1
124 echo "keytab w/o name"
125 ${acquire_cred} \
126 --acquire-type=accept || exit 1
128 echo "keytab w/ wrong name"
129 ${acquire_cred} \
130 --acquire-type=accept --kerberos \
131 --acquire-name=host@host2.test.h5l.se 2>/dev/null && exit 1
133 echo "init using keytab"
134 ${acquire_cred} \
135 --kerberos \
136 --acquire-type=initiate \
137 --acquire-name=host@host.test.h5l.se > /dev/null || exit 1
139 echo "init using keytab (loop 10)"
140 ${acquire_cred} \
141 --kerberos \
142 --acquire-type=initiate \
143 --loops=10 \
144 --acquire-name=host@host.test.h5l.se > /dev/null || exit 1
146 echo "init using keytab (loop 10, target)"
147 ${acquire_cred} \
148 --kerberos \
149 --acquire-type=initiate \
150 --loops=10 \
151 --target=host@host.test.h5l.se \
152 --acquire-name=host@host.test.h5l.se > /dev/null || exit 1
154 echo "init using keytab (loop 10, kerberos)"
155 ${acquire_cred} \
156 --acquire-type=initiate \
157 --loops=10 \
158 --kerberos \
159 --acquire-name=host@host.test.h5l.se > /dev/null || exit 1
161 echo "init using keytab (loop 10, target, kerberos)"
162 ${acquire_cred} \
163 --acquire-type=initiate \
164 --loops=10 \
165 --kerberos \
166 --target=host@host.test.h5l.se \
167 --acquire-name=host@host.test.h5l.se > /dev/null || exit 1
169 echo "init using existing cc"
170 ${acquire_cred} \
171 --kerberos \
172 --name-type=user-name \
173 --acquire-type=initiate \
174 --acquire-name=user || exit 1
176 KRB5CCNAME=${nocache}
178 echo "fail init using existing cc"
179 ${acquire_cred} \
180 --kerberos \
181 --name-type=user-name \
182 --acquire-type=initiate \
183 --acquire-name=user 2>/dev/null && exit 1
185 echo "use gss_krb5_ccache_name for user"
186 ${acquire_cred} \
187 --kerberos \
188 --name-type=user-name \
189 --ccache=${cache} \
190 --acquire-type=initiate \
191 --acquire-name=user >/dev/null || exit 1
193 KRB5CCNAME=${cache}
194 KRB5_KTNAME=${nokeytab}
196 echo "kcred"
197 ${test_kcred} || exit 1
199 ${kdestroy} -c ${cache}
201 KRB5_KTNAME="${keytab}"
203 echo "init using keytab"
204 ${acquire_cred} \
205 --kerberos \
206 --acquire-type=initiate \
207 --acquire-name=host@host.test.h5l.se 2>/dev/null || exit 1
209 echo "init using keytab (ccache)"
210 ${acquire_cred} \
211 --kerberos \
212 --acquire-type=initiate \
213 --ccache=${cache} \
214 --acquire-name=host@host.test.h5l.se 2>/dev/null || exit 1
216 trap "" EXIT
218 echo "killing kdc (${kdcpid})"
219 kill ${kdcpid} 2> /dev/null
221 exit $exitcode